# Installment Transaction Service
Installment Transaction Service

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://cert.api.visa.com | Sandbox server |

---
## Installment Transaction Service API - Deprecated
Financial Institution (FI) requests Visa Installments Service (VIS) for the list of confirmed or cancelled installment transactions for a given time-period, so they can process installment conversion together with the clearing file received from payment network. Financial Institution performs cancel and refund accordingly.

### [POST] /installments/planAcceptances/cancel
**Cancel plan acceptances**

Plan Cancellation API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |

#### Request Body

Plan acceptance cancellation information

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"refundAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"transactionID"**: string, **"refundTransactionID"**: string, **"vInstallmentPlanAcceptanceID"**: string, **"vinstallmentPlanAcceptanceID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"201"**: object, **"UpdatePlanAcceptanceResponse"**: { **"transactionId"**: string, **"cancellationStatus"**: string, **"cancellationDateTime"**: string, **"vinstallmentPlanAcceptanceId"**: string } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/candidates/batch
**Check Consumer Eligibility Batch**

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |

#### Request Body

list of mobile phone numbers

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"consumerInfo"**: [ { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"201"**: object, **"ConsumerEligibilityBatchResponse"**: { **"failureCount"**: integer, **"successCount"**: integer, **"batchExpirationDate"**: string, **"vEligibilityBatchID"**: string } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/plans/{planID}/planAcceptances
**Confirm plan acceptance**

Plan Selection API

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| planID | path | A PlanID of an available plan | Yes | string | simple | No |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |

#### Request Body

Plan acceptance confirmation information

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"vTransactionID"**: string, **"transactionAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"transactionDateTime"**: string, **"externalTransactionID"**: string, **"transactionDescriptor"**: string, **"vInstallmentPlanTermsAndConditionsVersion"**: { **"url"**: string, **"versionNumber"**: string } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"201"**: object, **"ConfirmPlanAcceptanceResponse"**: { **"vTransactionID"**: string, **"vInstallmentPlanID"**: string, **"planAcceptanceStatus"**: string, **"vInstallmentPlanAcceptanceID"**: string } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [GET] /installments/candidates/batch/{vCandidatesBatchID}
**Check Consumer Eligibility Batch Results by Batch ID**

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| vCandidatesBatchID | path | Batch id of the request job to getPlan the eligibility check results for the batch job submitted earlier | Yes | string | simple | No |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |
| page | query | Results page you want to retrieve (0..N) | No | integer | form | Yes |
| size | query | Number of records per page | No | integer | form | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | ok | **application/json**: { **"ConsumerEligibilityBatchDetailResponse"**: { **"batchData"**: { **"last"**: boolean, **"size"**: integer, **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"content"**: [ { **"errors"**: [ { **"error"**: string } ], **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"issuerBrandName"**: string, **"eligibilityStatus"**: boolean } ], **"pageable"**: { **"sort"**: { **"empty"**: boolean, **"sorted"**: boolean, **"unsorted"**: boolean }, **"paged"**: boolean, **"offset"**: long, **"unpaged"**: boolean, **"pageSize"**: integer, **"pageNumber"**: integer }, **"totalPages"**: integer, **"totalElements"**: long, **"numberOfElements"**: integer }, **"batchError"**: string, **"batchStatus"**: string, <br>**Available values:** "SUBMITTED", "COMPLETED", "FAILED", **"batchExpirationDate"**: string, **"veligibilityBatchID"**: string } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/eligiblePlans
**Fetch plan options**

Eligibility Check API - Fetch Installment Plan Options

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |

#### Request Body

Consumer Information

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"txnAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"201"**: object, **"InstallmentOffersResponse"**: { **"fees"**: [ { **"rate"**: number, **"type"**: string, <br>**Available values:** "CONSUMER", "ISSUER_TO_ACQUIRER", "ACQUIRER_TO_ISSUER", **"amount"**: number } ], **"name"**: string, **"type"**: string, **"partnerID"**: string, **"promotionID"**: string, **"promotionCode"**: string, **"totalPlanCost"**: { **"amount"**: string, **"currencyCode"**: string }, **"txnAmountRanges"**: [ { **"maximumTxnAmount"**: string, **"minimumTxnAmount"**: string } ], **"installmentAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"termsAndConditions"**: [ { **"status"**: string, **"tncUrl"**: string, **"version"**: string, **"createdOn"**: string } ], **"vInstallmentPlanID"**: string, **"effectiveDateRanges"**: [ { **"endDate"**: string, **"startDate"**: string } ], **"totalFixedFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"installmentFrequency"**: string, **"numberOfInstallments"**: integer, **"lastInstallmentAmount"**: { **"amount"**: string, **"currencyCode"**: string }, **"totalVariableFeeAmount"**: { **"amount"**: string, **"currencyCode"**: string } } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

### [POST] /installments/candidates
**Check Consumer Eligibility for Installment Plans**

Eligibility Check API - Initiate Check Consumer Eligibility

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| X-SERVICE-CONTEXT | header | X-SERVICE-CONTEXT | Yes | string | simple | No |

#### Request Body

list of mobile phone numbers

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"consumerInfo"**: [ { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"201"**: object, **"ConsumerEligibilityResponse"**: { **"consumerInfo"**: { **"hashedURN"**: string, **"encEmailAddress"**: string, **"encMobileNumber"**: string, **"encAccountNumber"**: string }, **"issuerBrandName"**: string } }<br> |
| 401 | Unauthorized |  |
| 403 | Forbidden |  |
| 404 | Not Found |  |

---
## Installment Transaction Service API V2
APIs used by Sellers (Merchants/Acquirers/Gateways/Other Merchant Enablers) or issuers (in case of post-purchase model) to enable Visa Installment Solutions for both e-commerce and In-Store based on installment plans defined by issuers.

### [POST] /installments/v2/planAcceptances
**Plan Selection API**

This API enables the Merchant participant to confirm an Installment plan selection when the cardholder selects a plan among the eligible plan options and accepts terms and conditions for that plan. This API can also be used in post-purchase scenarios. The Merchant participant must get cardholders’ consent on the terms and conditions for the selected Installment plan before invoking this API. <p> Plan Selection can be made by providing either the <code>orderInfo</code> or <code>transactionInfo</code>. The <code>orderInfo</code> is recommended to be used only when <code>transactionInfo</code> details are not available and <code>orderInfo.orderAmount</code> is used to restrict the maximum transaction amount that can be applied on the created Plan Acceptance. </p>

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| v-c-idempotency-key | header | Unique ID for every API request - an optional header. Generated by the API client. Used for idempotency. | No | string (uuid) | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"encAccountNumber"**: byte, **"tokenAccountNumber"**: string, **"vProvisionedTokenID"**: string, **"paymentAccountReference"**: string } & { **"tokenReferenceID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Plan Acceptance was successfully created<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br>**v-c-idempotency-key**: Unique ID for the API response. v-c-idempotency-key is echoed back. Used for idempotency.<br> | **application/json**: { **"vPlanID"**: string (uuid), **"vPlanIDRef"**: string, **"createdDateTime"**: dateTime, **"transactionInfo"**: { **"authCode"**: string, **"currency"**: string, **"vTransactionID"**: string, **"externalTransactionRef"**: string } & { **"dateTime"**: dateTime, **"transactionAmount"**: long } & { **"installmentTransactions"**: [ { **"status"**: string, <br>**Available values:** "CONFIRMED", "CANCELLED", "PENDING_CONFIRMATION", "PENDING_CANCELLATION", "PARTIALLY_REFUNDED", **"vInstallmentTransactionID"**: string (uuid) } & { **"clearingAmount"**: long, **"clearingDateTime"**: dateTime, **"settlementCurrency"**: string, **"clearingSequenceNumber"**: string, **"acquirerReferenceNumber"**: string } ] }, **"vPlanAcceptanceID"**: string (uuid), **"paymentAccountReference"**: string }<br> |
| 400 | The 400 (Bad Request) HTTP Status code indicates that the server cannot or will not process the request due to an apparent client error. This can happen if you are trying to   + Invoke an API request with missing or invalid parameters.   + PlanAcceptances for Debit must include only <code>orderInfo</code> and must not include <code>transactionInfo</code>. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to   + Invoke an API request for a resource that is not part of your project.   + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used.   + The Consumer Information provided in the request is not eligible for the Installment plan.The value of <code>errorResponse.reason</code> is <code>consumerInfoNotEligible</code>   + The Partner details given in the request is not authorized for on behalf of calls. The value of <code>errorResponse.reason</code> is <code>forbiddenClientIDAccess</code>   + The Merchant is not allowed to perform Installment Plan Acceptance. The value of <code>errorResponse.reason</code> is <code>planAcceptanceDisabled</code>   + The Merchant profile is not enabled for Debit Transactions.The value of <code>errorResponse.reason</code> is <code>forbiddenException</code>   + Cross Border Transaction are not allowed on Debit PANs.The value of <code>errorResponse.reason</code> is <code>forbiddenException</code>   + Post Purchase Transaction are not allowed on Debit PANs.The value of <code>errorResponse.reason</code> is <code>forbiddenException</code>   + Plan Acceptances are not allowed on expired cards.The value of <code>errorResponse.reason</code> is <code>consumerInfoNotEligible</code> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | The referenced Installment Plan was not found, deleted, or expired. The value of <code>errorResponse.reason</code> is <code>planNotFound</code> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

#### Callback: planAcceptanceStatusChange

##### [POST] `{postbackNotificationUrl}`
**Installment PlanAcceptance Status Change Notifications**

These are API calls initiated by the Visa backend, made to the Visa Partner’s backend servers.
The <code>postbackNotificationUrl</code> is configured by the Visa partners during onboarding.
+ This callback is available only for those clients that own the BIN for the PAN involved – <b>Lenders/Processors/BIN users/BIN owners</b>.
+ Invoked when one or more plan acceptances status change events are available for this lender.
+ These callbacks are sent only if the issuer has opted-in (as in the onboarding profile).
+ There will be 2 retries with random times from 1-30 minutes, if there are any 5XX or 404 errors returned from the client/partner.
<b>Note:</b> This callback is invoked only when a status change occurs at the plan acceptance level.
  For example, if a transaction is added to the plan acceptance and the transaction is not confirmed, since there is no change to the overall status
  of the plan acceptance, there will be no PlanAcceptanceStatusChangeCallback invoked. However, InstallmentTransactionStatusChangeCallback will be invoked for that action.
  If there are many installment transactions associated with a plan acceptance, and if all of them are confirmed, then a plan acceptance confirmation callback is invoked.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| x-message-tracking-id | header | Tracking ID for callback and notification sent by Visa | Yes | string | No |
| postbackNotificationUrl | path |  | Yes | string | No |
| apiKey | query |  | Yes | string | Yes |
| x-pay-token | header | See [XPayToken definition in Security Schemes](#/components/securitySchemes/x-pay-token) for details <SchemaDefinition schemaRef="#/components/securitySchemes/x-pay-token" />  | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"status"**: string, <br>**Available values:** "CREATED", "CANCELLED", "UPDATED", "CONFIRMED", **"cardType"**: string, <br>**Available values:** "CREDIT", "DEBIT", "PREPAID", <br>**Default:** CREDIT, **"cardBrand"**: string, <br>**Available values:** "VISA", "NON_VISA", "MASTERCARD", "AMERICAN_EXPRESS", "DISCOVER", "JCB", "UNIONPAY", "DINERSCLUB", <br>**Default:** VISA, **"orderInfo"**: { **"currency"**: string, **"orderAmount"**: long }, **"crossBorder"**: boolean, **"installmentPlan"**: { **"name"**: string, **"type"**: string, <br>**Available values:** "MARKET", "BI_LATERAL", "ISSUER_DEFAULT", "ISSUER_PROMOTION", "ISSUER_HYBRID", **"vPlanID"**: string (uuid), **"fundedBy"**: [ string, <br>**Available values:** "CONSUMER", "MERCHANT" ], **"vPlanIDRef"**: string, **"islamicPlan"**: boolean, **"promotionInfo"**: { **"promotionID"**: string, **"promotionCode"**: string }, **"termsAndConditions"**: [ { **"url"**: string, **"text"**: string, **"version"**: integer, **"languageCode"**: string } ], **"installmentFrequency"**: string, <br>**Available values:** "WEEKLY", "BIWEEKLY", "MONTHLY", "BIMONTHLY", **"numberOfInstallments"**: number (integer) } & { **"costInfo"**: { **"feeInfo"**: [ { **"type"**: string, <br>**Available values:** "ACQUIRER_TO_ISSUER", "ACQUIRER_TO_VISA", "ISSUER_TO_ACQUIRER", "ISSUER_TO_VISA", "ISSUER_TO_VISA_SCHEDULING_FEES", **"flatFee"**: long, **"ratePercentage"**: integer } ], **"currency"**: string, **"totalFees"**: long, **"totalPlanCost"**: long, **"lastInstallment"**: { **"amount"**: long, **"totalAmount"**: long, **"installmentFee"**: long }, **"firstInstallment"**: { **"upfrontFee"**: long, **"totalAmountExcludingUpfrontFee"**: long } & { **"amount"**: long, **"totalAmount"**: long, **"installmentFee"**: long }, **"totalUpfrontFees"**: long, **"totalRecurringFees"**: long, **"annualPercentageRate"**: integer } }, **"messageMetadata"**: { **"type"**: string, <br>**Available values:** "BATCH_COMPLETED", "ELIGIBILITY", "PLANACCEPTANCE_STATUS_UPDATE", "INSTALLMENT_TRANSACTION_STATUS_UPDATE", "BILATERAL_PLAN_PARTNER_STATUS_UPDATE", **"vMessageID"**: string (uuid), **"createdDateTime"**: string (date-time-nooffset) }, **"encAccountNumber"**: byte, **"externalClientID"**: string, **"statusTransitions"**: { **"createdDateTime"**: string (date-time-ms-nooffset), **"updatedDateTime"**: string (date-time-ms-nooffset), **"confirmedDateTime"**: string (date-time-ms-nooffset), **"cancellationDateTime"**: string (date-time-ms-nooffset) }, **"vPlanAcceptanceID"**: string (uuid), **"encSecondaryAccountNumber"**: byte, **"originalEncSecondaryAccountNumber"**: byte }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | API authorized error caused due to any of the following reasons:   + x-pay-token is not present or blank or not in valid format.   + Timestamp field not in valid UTC timestamp format.   + APIKey not present in request.   + APIKey is not active.   + APIKey not valid.   + APIKey not active.  |
| 403 | Forbidden |
| 500 | Internal server error |
| 503 | Service unavailable |
| 2XX | Callback successfully processed and no retries will be performed |

##### Security

| Security Schema | Scopes |
| --------------- | ------ |
| apiKey |  | x-pay-token |  |

#### Callback: installmentTransactionStatusChange

##### [POST] `{postbackNotificationUrl}`
**Installment Transaction Status Change Notifications**

These are API calls initiated by the Visa backend, made to the Visa Partner’s backend servers.
The <code>postbackNotificationUrl</code> is configured by the Visa partners during onboarding. The
+ This callback is available only for those clients that own the BIN for the PAN involved – <b>Lenders/Processors/BIN users/BIN owners</b>.
+ Invoked when InstallmentTransaction status is updated. Installment Transaction corresponds to a clearing and a installment payment schedule.
+ These callbacks are sent only if the issuer has opted-in (as in the onboarding profile).
+ There will be 2 retries with random times from 1-30 minutes, if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| x-message-tracking-id | header | Tracking ID for callback and notification sent by Visa | Yes | string | No |
| postbackNotificationUrl | path |  | Yes | string | No |
| apiKey | query |  | Yes | string | Yes |
| x-pay-token | header | See [XPayToken definition in Security Schemes](#/components/securitySchemes/x-pay-token) for details <SchemaDefinition schemaRef="#/components/securitySchemes/x-pay-token" />  | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"vPlanID"**: string (uuid), **"authCode"**: string, **"cardType"**: string, <br>**Available values:** "CREDIT", "DEBIT", "PREPAID", <br>**Default:** CREDIT, **"currency"**: string, **"cardBrand"**: string, <br>**Available values:** "VISA", "NON_VISA", "MASTERCARD", "AMERICAN_EXPRESS", "DISCOVER", "JCB", "UNIONPAY", "DINERSCLUB", <br>**Default:** VISA, **"vPlanIDRef"**: string, **"crossBorder"**: boolean, **"promotionInfo"**: { **"promotionID"**: string, **"promotionCode"**: string }, **"sourceCurrency"**: string, **"vTransactionID"**: string, **"messageMetadata"**: { **"type"**: string, <br>**Available values:** "BATCH_COMPLETED", "ELIGIBILITY", "PLANACCEPTANCE_STATUS_UPDATE", "INSTALLMENT_TRANSACTION_STATUS_UPDATE", "BILATERAL_PLAN_PARTNER_STATUS_UPDATE", **"vMessageID"**: string (uuid), **"createdDateTime"**: string (date-time-nooffset) }, **"encAccountNumber"**: byte, **"externalClientID"**: string, **"transactionAmount"**: long, **"vPlanAcceptanceID"**: string (uuid), **"installmentTransaction"**: { **"status"**: string, <br>**Available values:** "PENDING_CONFIRMATION", "CONFIRMED", "PENDING_CANCELLATION", "CANCELLED", "PARTIALLY_REFUNDED", **"vInstallmentTransactionID"**: string (uuid) } & { **"clearingAmount"**: long, **"clearingDateTime"**: dateTime, **"settlementCurrency"**: string, **"clearingSequenceNumber"**: string, **"acquirerReferenceNumber"**: string } & { **"refundAmount"**: long, **"sourceCurrency"**: string, **"lastRefundDateTime"**: dateTime, **"refundAmountInSourceCurrency"**: long, **"clearingAmountInSourceCurrency"**: long }, **"transactionRefundAmount"**: long, **"encSecondaryAccountNumber"**: byte, **"originalEncSecondaryAccountNumber"**: byte, **"transactionAmountInSourceCurrency"**: long, **"transactionRefundAmountInSourceCurrency"**: long }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | API authorized error caused due to any of the following reasons:   + x-pay-token is not present or blank or not in valid format.   + Timestamp field not in valid UTC timestamp format.   + APIKey not present in request.   + APIKey is not active.   + APIKey not valid.   + APIKey not active.  |
| 403 | Forbidden |
| 500 | Internal server error |
| 503 | Service unavailable |
| 2XX | Callback successfully processed and no retries will be performed |

##### Security

| Security Schema | Scopes |
| --------------- | ------ |
| apiKey |  | x-pay-token |  |

### [POST] /installments/v2/planAcceptances/transactions/search
**Retrieve Plan Acceptance Transactions - Search**

This API retrieves the list of Installment Transactions associated with a PlanAcceptance for a given set of criteria. A PlanAcceptance can be associated with one or more ISO transactions or a part of an ISO transaction (one clearing/settlement record among the many clearing/settlement records in a ISO transaction) The results are sorted by plan acceptance <code>createdDateTime</code> in reverse chronological order.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| size | query |  | No | integer, <br>**Default:** 100 | Yes |
| page | query |  | No | integer | Yes |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"encAccountNumber"**: byte, **"tokenAccountNumber"**: string, **"vProvisionedTokenID"**: string, **"paymentAccountReference"**: string } & { **"tokenReferenceID"**: string } & { **"category"**: string, **"merchantReferenceID"**: string, **"partnerMerchantReferenceID"**: string } & { **"authCode"**: string, **"currency"**: string, **"vTransactionID"**: string, **"minTransactionAmount"**: long, **"externalTransactionRef"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | PlanAcceptance Transactions Results Page<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"last"**: boolean, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"totalCount"**: integer, **"totalPages"**: integer, **"resultsCount"**: integer } & { **"content"**: [ { **"authCode"**: string, **"currency"**: string, **"vTransactionID"**: string, **"externalTransactionRef"**: string } & { **"dormant"**: string, <br>**Available values:** "true", "false", <br>**Default:** false, **"cardBrand"**: string, <br>**Available values:** "VISA", "NON_VISA", "MASTERCARD", "AMERICAN_EXPRESS", "DISCOVER", "JCB", "UNIONPAY", "DINERSCLUB", <br>**Default:** VISA, **"vPlanIDRef"**: string, **"crossBorder"**: boolean, **"transactionAmount"**: long, **"vPlanAcceptanceID"**: string (uuid), **"installmentTransactions"**: [ { **"status"**: string, <br>**Available values:** "CONFIRMED", "CANCELLED", "PENDING_CONFIRMATION", "PENDING_CANCELLATION", "PARTIALLY_REFUNDED", **"vInstallmentTransactionID"**: string (uuid) } & { **"clearingAmount"**: long, **"clearingDateTime"**: dateTime, **"settlementCurrency"**: string, **"clearingSequenceNumber"**: string, **"acquirerReferenceNumber"**: string } & { **"refundAmount"**: long, **"lastRefundDateTime"**: dateTime } ], **"transactionRefundAmount"**: long } ] }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [POST] /installments/v2/vtms/offerConfirmation
**Offer Confirmation**

This API submits the offer confirmation to Visa. Visa will deliver offer information to the Issuer in the authorization message.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No |  |

#### Responses

| Code | Description |
| ---- | ----------- |
| 201 |  |

### [PUT] /installments/v2/merchantPreferences
**Update Merchant Preferences API**

This API updates the Merchant preferences like bilateral plan related preferences or any other preferences. Seller can Opt-In or Opt-Out of a Bilateral Plan Association using this API.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"planPreferences"**: { **"vPlanID"**: string (uuid), **"bilateralPlanAction"**: string, <br>**Available values:** "OPT_IN", "OPT_OUT" }, **"partnerMerchantReferenceID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Merchant Preference successfully updated<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"planPreferences"**: { **"vPlanID"**: string (uuid), **"bilateralPlanAction"**: string, <br>**Available values:** "OPT_IN", "OPT_OUT" }, **"partnerMerchantReferenceID"**: string }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | The referenced Installment Plan was not found, deleted, or expired. The value of <code>errorResponse.reason</code> is <code>planNotFound</code> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 409 | Conflict<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

#### Callback: partnerBilateralPlanStatusChange

##### [POST] `{postbackNotificationUrl}`
**Postback Notifications**

These are API calls initiated by the Visa backend to the Visa Partner’s backend servers.
+ The <code>postbackNotificationUrl</code> is configured by the Visa partners during onboarding.
+ Invoked whenever the partner(Issuer) associates/dissociates or make changes to Bilateral Plan assigned to Sellers.
+ Invoked whenever the partner(Seller) accepts or rejects or cancels a bilateral plan assigned to them by Issuers
+ There will be 2 retries with random times from 1-30 minutes if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| x-message-tracking-id | header | Tracking ID for callback and notification sent by Visa | Yes | string | No |
| postbackNotificationUrl | path |  | Yes | string | No |
| apiKey | query |  | Yes | string | Yes |
| x-pay-token | header | See [XPayToken definition in Security Schemes](#/components/securitySchemes/x-pay-token) for details <SchemaDefinition schemaRef="#/components/securitySchemes/x-pay-token" />  | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"name"**: string, **"vPlanID"**: string (uuid), **"planType"**: string, <br>**Available values:** "BI_LATERAL", **"statusType"**: string, <br>**Available values:** "PLAN_ASSOCIATED", "PLAN_DISSOCIATED", "PLAN_OPT_IN", "PLAN_OPT_OUT", "PLAN_TERMS_AND_CONDITIONS_UPDATED", "PLAN_EXPIRY_UPDATED", "PLAN_ACTIVATED", **"vPlanIDRef"**: string, **"partnerName"**: string, **"promotionInfo"**: { **"promotionID"**: string, **"promotionCode"**: string }, **"messageMetadata"**: { **"type"**: string, <br>**Available values:** "BATCH_COMPLETED", "ELIGIBILITY", "PLANACCEPTANCE_STATUS_UPDATE", "INSTALLMENT_TRANSACTION_STATUS_UPDATE", "BILATERAL_PLAN_PARTNER_STATUS_UPDATE", **"vMessageID"**: string (uuid), **"createdDateTime"**: string (date-time-nooffset) }, **"termsAndConditions"**: [ { **"url"**: string, **"text"**: string, **"version"**: integer, **"languageCode"**: string } ], **"effectiveDateRanges"**: [ { **"endDate"**: date, **"startDate"**: date } ], **"installmentFrequency"**: string, <br>**Available values:** "WEEKLY", "BIWEEKLY", "MONTHLY", "BIMONTHLY", **"numberOfInstallments"**: number (integer), **"partnerMerchantReferenceID"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | Authorized error due to any of the following reasons:   + x-pay-token is not present, is blank, or is not in a valid format.   + Timestamp field not in UTC timestamp format.   + apiKey not present in request.   + apiKey is not active.   + apiKey not valid.   + apiKey not active.  |
| 403 | Forbidden |
| 500 | Internal Server Error |
| 503 | Service Unavailable |
| 2XX | Callback successfully processed; no retries will be performed. |

##### Security

| Security Schema | Scopes |
| --------------- | ------ |
| apiKey |  | x-pay-token |  |

### [POST] /installments/v2/clients
**Client Onboarding API**

This API enables Partners to onboard clients associated with them on to Visa Installments. The basic details captured in this API will be associated with the Client Identifier used by the Partner to invoke the API and only the Partner will be allowed to access the API on behalf of the Client.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| v-c-idempotency-key | header | Unique ID for every API request - an optional header. Generated by the API client. Used for idempotency. | No | string (uuid) | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"city"**: string, **"phone"**: string, **"address1"**: string, **"address2"**: string, **"postalCode"**: string, **"countryCode"**: string, **"cardAcceptorId"**: string, **"primaryLegalName"**: string, **"primaryTradeName"**: string, **"primaryWebsiteURL"**: string, **"stateProvinceCode"**: string, **"primaryContactEmail"**: string, **"primaryContactLastName"**: string, **"onBehalfOfRelationships"**: [ { **"relationshipType"**: string, <br>**Available values:** "OBO_FUNDING_FEE_COLLECTOR", "OBO_SERVICE_FEE_COLLECTOR", **"partnerReferenceID"**: string, **"onBehalfOfReferenceID"**: string } ], **"primaryContactFirstName"**: string, **"partnerMerchantReferenceID"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Successful Merchant Creation Response<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br>**v-c-idempotency-key**: Unique ID for the API response. v-c-idempotency-key is echoed back. Used for idempotency.<br> | **application/json**: { **"city"**: string, **"phone"**: string, **"address1"**: string, **"address2"**: string, **"postalCode"**: string, **"countryCode"**: string, **"cardAcceptorId"**: string, **"primaryLegalName"**: string, **"primaryTradeName"**: string, **"primaryWebsiteURL"**: string, **"stateProvinceCode"**: string, **"primaryContactEmail"**: string, **"primaryContactLastName"**: string, **"onBehalfOfRelationships"**: [ { **"relationshipType"**: string, <br>**Available values:** "OBO_FUNDING_FEE_COLLECTOR", "OBO_SERVICE_FEE_COLLECTOR", **"partnerReferenceID"**: string, **"onBehalfOfReferenceID"**: string } ], **"primaryContactFirstName"**: string, **"partnerMerchantReferenceID"**: string } & { **"status"**: string, <br>**Available values:** "ONBOARDED" }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 409 | Conflict<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [GET] /installments/v2/candidates/batch/{vBatchID}
**Matched Candidates Batch Result API**

This API retrieves the result of a previously submitted Matched Candidates Batch request identified by the batch ID.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| vBatchID | path |  | Yes | string (uuid) | No |
| size | query |  | No | <br>**Default:** 1000 | Yes |
| page | query |  | No | integer | Yes |
| eligibilityStatus | query |  | No | string, <br>**Available values:** "MATCHED", "NOT_MATCHED", "ERROR", <br>**Default:** MATCHED | Yes |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Get matched candidates results for the batch request submitted earlier. + All of the data submitted in the original HTTP request is echoed back in the response. + The order of the results is preserved (when compared to the order of items in the original request body). + If there were errors processing this candidate, an <code>errorResponse</code> is returned. In this case, the <code>eligibilityStatus</code> is 'ERROR'. + If any of the required fields in <code>consumerInfo</code> are not provided in the input, an empty string is returned for those fields with a 400 <code>errorMesage.details</code> entry pointing to the missing entries. + When <code>batchStatus == SUBMITTED</code> there will be no <code>content</code> in the response. + When <code>batchStatus == COMPLETED</code> all fields will be available in the response. + If the batch results are not ready, a Retry-After response header should be sent, when appropriate (Default value 600 seconds). <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"last"**: boolean, **"empty"**: boolean, **"first"**: boolean, **"number"**: integer, **"totalCount"**: integer, **"totalPages"**: integer, **"resultsCount"**: integer } & { **"content"**: [ { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string }, **"encAccountNumber"**: byte, **"eligibilityStatus"**: string, <br>**Available values:** "MATCHED", "NOT_MATCHED", "ERROR", <br>**Default:** MATCHED, **"tokenAccountNumber"**: string, **"vProvisionedTokenID"**: string } ], **"vBatchID"**: string (uuid), **"batchType"**: string, <br>**Available values:** "CARDHOLDER_ENROLLMENT", "CARDHOLDER_ENROLLMENT_UPDATE", "CARDHOLDER_ENROLLMENT_DELETE", "PLAN_ACCEPTANCE_IRREGULAR_PAYMENTS", "CANDIDATES", **"batchStatus"**: string, <br>**Available values:** "SUBMITTED", "COMPLETED", **"batchExecutionDateTime"**: dateTime, **"batchExpirationDateTime"**: dateTime }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to   + Invoke an API request for a resource that is not part of your project.   + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used.   + The Client does not have the permissions to view the <code>batchId</code>. The value of <code>errorResponse.reason</code> is <code>forbiddenClientIDBatchIDAccess</code> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 404 | Batch not found. The batch corresponding to the vBatchID is either expired or invalid.<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [POST] /installments/v2/plans/match
**Matched Eligible Installment Plans API**

This API retrieves eligible Installment plan information to provide Installment offers to a cardholder during checkout based on a set of criteria. The plans are looked up against all of the participating Issuers. This API checks the eligibility of a Payment Transaction for Installments plans and also checks against the Issuer Conditions for eligibility. + The result of this operation, when successful, is one or more eligible Installment plans presented as eligible plans. + If there are no active plans matching the given set of criteria, then an empty array will be returned in this API response. + Any plans that are already expired or are expiring in the next 24 hrs will not be returned in this API response.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"encAccountNumber"**: byte, **"tokenAccountNumber"**: string, **"vProvisionedTokenID"**: string, **"paymentAccountReference"**: string } & { **"preferences"**: { **"capabilities"**: { **"visIndicatorCapability"**: string, <br>**Available values:** "SUPPORTED", "NOT_SUPPORTED" }, **"installmentMode"**: string, <br>**Available values:** "DURING_PURCHASE", "POST_PURCHASE", **"acceptanceChannel"**: string, <br>**Available values:** "IN_PERSON", "E_COMMERCE", <br>**Default:** IN_PERSON }, **"merchantInfo"**: { **"category"**: string, **"merchantReferenceID"**: string, **"partnerMerchantReferenceID"**: string }, **"transactionAmount"**: long, **"transactionCurrency"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | A list of matched/eligible Installment plans. If none match, an empty array is returned.<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"matchedPlans"**: [ { **"name"**: string, **"type"**: string, <br>**Available values:** "MARKET", "BI_LATERAL", "ISSUER_DEFAULT", "ISSUER_PROMOTION", "ISSUER_HYBRID", **"vPlanID"**: string (uuid), **"fundedBy"**: [ string, <br>**Available values:** "CONSUMER", "MERCHANT" ], **"vPlanIDRef"**: string, **"islamicPlan"**: boolean, **"promotionInfo"**: { **"promotionID"**: string, **"promotionCode"**: string }, **"termsAndConditions"**: [ { **"url"**: string, **"text"**: string, **"version"**: integer, **"languageCode"**: string } ], **"installmentFrequency"**: string, <br>**Available values:** "WEEKLY", "BIWEEKLY", "MONTHLY", "BIMONTHLY", **"numberOfInstallments"**: number (integer) } & { **"costInfo"**: { **"feeInfo"**: [ { **"type"**: string, <br>**Available values:** "CONSUMER", "CONSUMER_UPFRONT", "MERCHANT_FUNDING", "MERCHANT_SERVICE", **"flatFee"**: long, **"ratePercentage"**: integer, **"monthlyRatePercentage"**: integer } ], **"currency"**: string, **"totalFees"**: long, **"totalPlanCost"**: long, **"lastInstallment"**: { **"amount"**: long, **"totalAmount"**: long, **"installmentFee"**: long }, **"firstInstallment"**: { **"upfrontFee"**: long, **"totalAmountExcludingUpfrontFee"**: long } & { **"amount"**: long, **"totalAmount"**: long, **"installmentFee"**: long }, **"totalUpfrontFees"**: long, **"totalRecurringFees"**: long, **"annualPercentageRate"**: integer } } ], <br>**Default:** , **"merchantInfo"**: { **"category"**: string, **"merchantReferenceID"**: string, **"partnerMerchantReferenceID"**: string }, **"transactionAmount"**: long, **"transactionCurrency"**: string, **"paymentAccountReference"**: string }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to   + Invoke an API request for a resource that is not part of your project.   + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used.   + The Partner details given in the request is not authorized for on behalf of calls. The value of <code>errorResponse.reason</code> is <code>forbiddenClientIDAccess</code>  |  |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

### [POST] /installments/v2/candidates/batch/match
**Matched Candidates API - Batch**

This API allows Merchant participants to check if an individual cardholder is (or a set of cardholders are) enabled for Installments, in order to offer Installments to a qualified shopper during purchase. It is an optional API and does not return Installment offers. For retrieving Installment offers specific to a given Installment transaction, see Matched Eligible Installment Plans API.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |

#### Request Body

Consumer information to use when checking for Installments eligibility.

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"encAccountNumbers"**: byte, **"tokenAccountNumbers"**: [ string ], **"vProvisionedTokenIDs"**: [ string ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Candidates eligibility batch job submitted successfully<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"vBatchID"**: string (uuid), **"batchType"**: string, <br>**Available values:** "CARDHOLDER_ENROLLMENT", "CARDHOLDER_ENROLLMENT_UPDATE", "CARDHOLDER_ENROLLMENT_DELETE", "PLAN_ACCEPTANCE_IRREGULAR_PAYMENTS", "CANDIDATES", **"batchExpirationDateTime"**: dateTime }<br> |
| 400 | The <code>errorResponse.details</code> part of the error response can provide a list of fields that failed data validation constraints and errorResponse.reason values for this error include:   <ul>   <li><code>invalidRequest</code>The API server could not understand the request; for example, base64 decoding failed, the field is not in a particular format, etc.   </ul> <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 401 | API authorized error caused due to any of the following reasons: + x-pay-token is not present, blank, or not in a valid format. + Timestamp field not in valid UTC timestamp format. + Version field is invalid. + Token's timestamp is more than 8 minutes off from the current time. + Token hash mismatch. + APIKey not present in request. + APIKey is not active. + APIKey not valid. + APIKey not active. + Request has more than one authentication token, which is not supported <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 403 | The 403 (Forbidden) HTTP Status code indicates that the access failed due to insufficient permissions or the operation is not allowed. This can happen if you are trying to + Invoke an API request for a resource that is not part of your project. + Perform an operation that is not permitted in the given context  Check for the following:   + You are using a project and the credential for the project that includes the API being accessed.   + You created a project and received sandbox credentials for the API’s being called.   + You added the API being called to the project (if not already present) with the credentials that are being used. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 406 | Not Acceptable - Indicates that the "Accept:" header field is present in a request and none of the available representations for the response have a media type that is listed as acceptable.  This can happen when the requested API version is not available or unsupported; for example, when the version requested in the Accept: header is newer than the currently live/supported version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 410 | Gone - Indicates that the resource at this end point is no longer available. This is usually returned for old API versions that are not available anymore - EOL (End-of-Life). The content-type header in the response indicates the latest supported API version. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 413 | Payload Too Large<br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 429 | The Visa Developer Center project has clocked too many requests in a given amount of time.  Please contact Visa Support Representative if you want to increase the time limits. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 500 | Internal Server Error.  Please contact Visa Support Representative with a complete error message, full http request and response details. <br>**Headers:**<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |
| 503 | The Visa system is currently unable to handle the request due to a temporary overloading or maintenance of the server.  There may be a Retry-After header field to suggest an appropriate amount of time for the client to wait before retrying the request. The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received. <code>Retry-After = HTTP-date \|\| delay-seconds</code> examples: + <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code> + <code>Retry-After: 120</code>  Please contact Visa Support Representative if the issue persists. <br>**Headers:**<br>**Retry-After**: Header field to suggest an appropriate amount of time for the client to wait before retrying the request, typically after a 503 error or after a batch request when the batch job is not completed.
The value of this field can be either an HTTP-date or a number of seconds to delay after the response is received.
<code>Retry-After = HTTP-date || delay-seconds</code>
examples:
+ <code>Retry-After: Thu, 31 Dec 2020 23:59:59 GMT</code>
+ <code>Retry-After: 120</code>
<br>**ex-correlation-id**: Unique ID for the API response; ex-correlation-id is echoed back. Used for end-to-end tracing/debugging.<br> | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"reason"**: string, **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: string, **"status"**: integer } }<br> |

#### Callback: batchCompleted

##### [POST] `{postbackNotificationUrl}`
**Postback Notifications**

These are API calls initiated by the Visa backend to the Visa Partner’s backend servers.
+ The <code>postbackNotificationUrl</code> is configured by the Visa partners during onboarding.
+ Invoked whenever the enrollments batch request results are ready for Visa partner to pull the results from Visa using another API call.
+ There will be 2 retries with random times from 1-30 minutes if there are any 5XX or 404 errors returned from the client/partner.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| x-message-tracking-id | header | Tracking ID for callback and notification sent by Visa | Yes | string | No |
| postbackNotificationUrl | path |  | Yes | string | No |
| apiKey | query |  | Yes | string | Yes |
| x-pay-token | header | See [XPayToken definition in Security Schemes](#/components/securitySchemes/x-pay-token) for details <SchemaDefinition schemaRef="#/components/securitySchemes/x-pay-token" />  | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"vBatchID"**: string (uuid), **"batchType"**: string, <br>**Available values:** "CARDHOLDER_ENROLLMENT", "CARDHOLDER_ENROLLMENT_UPDATE", "CARDHOLDER_ENROLLMENT_DELETE", "PLAN_ACCEPTANCE_IRREGULAR_PAYMENTS", "CANDIDATES", **"batchStatus"**: string, <br>**Available values:** "SUBMITTED", "COMPLETED", **"messageMetadata"**: { **"type"**: string, <br>**Available values:** "BATCH_COMPLETED", "ELIGIBILITY", "PLANACCEPTANCE_STATUS_UPDATE", "INSTALLMENT_TRANSACTION_STATUS_UPDATE", "BILATERAL_PLAN_PARTNER_STATUS_UPDATE", **"vMessageID"**: string (uuid), **"createdDateTime"**: string (date-time-nooffset) }, **"batchExecutionDateTime"**: dateTime, **"batchExpirationDateTime"**: dateTime }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 401 | Authorized error due to any of the following reasons:   + x-pay-token is not present, is blank, or is not in a valid format.   + Timestamp field not in UTC timestamp format.   + apiKey not present in request.   + apiKey is not active.   + apiKey not valid.   + apiKey not active.  |
| 403 | Forbidden |
| 500 | Internal Server Error |
| 503 | Service Unavailable |
| 2XX | Callback successfully processed; no retries will be performed. |

##### Security

| Security Schema | Scopes |
| --------------- | ------ |
| apiKey |  | x-pay-token |  |

### [POST] /installments/v2/planAcceptances/{vPlanAcceptanceID}/transactions
**Transaction Association API**

This API is invoked after a plan acceptance is created. + In case of Post Purchase scenario,this API is used to associate a new clearing with a plan acceptance. + In case of During Purchase scenario,this API  is used to associate a new Transaction after authorization with a plan acceptance.   The sum of all associated transactions cannot exceed the order amount including buffer. It is important that the transaction amount (passed-in) needs to match the amount on the transaction   corresponding to the transactionID passed-in. + In case of ReAuthorized transaction,this API is used to swap existing transaction with the new Transaction

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| vPlanAcceptanceID | path |  | Yes | string (uuid) | No |
| ex-correlation-id | header | Unique ID for every API request - an optional header. Generated by the API client. Used for end-to-end tracing/debugging. | No | string | No |
| v-c-idempotency-key | header | Unique ID for every API request - an optional header. Generated by the API client. Used for idempotency. | No | string (uuid) | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
[...]
